﻿//DESCRIPTION:Convert Page Number Placeholder '#' into Text  
// A Jongware Script 11-Dec-2011  
// http://indesignsecrets.com/making-page-numbers-words-numbers.php
  
var allPages = app.activeDocument.pages;  
for (iterate=0; iterate<allPages.length; iterate++)  
{  
          customPageNumber (allPages[iterate]);  
}  
alert("Готово!");  
  
function customPageNumber (aPage)  
{  
          if (aPage.appliedMaster == null)  
                    return;  
  
  
          pageSide = (aPage.side == PageSideOptions.RIGHT_HAND) ? 1 : 0;  
          masterFrame = findFrameContaining (aPage.appliedMaster, pageSide, '#');  
          if (masterFrame != null)  
          {  
                    frame = findByLabel (aPage.pageItems, "page number");  
                    if (frame != null)  
                    {  
                              frame.removeOverride();  
                    }  
                    frame = masterFrame.override (aPage);  
                    frame.label = "page number";  
  
                    placeholder = frame.contents.indexOf ('#');  
                    if (placeholder != -1)  
                    {  
                              pageString = numberToText(Number(aPage.name));  
                              pageString = pageString.substr(0,1).toUpperCase()+pageString.substr(1);  
                              frame.characters[placeholder].contents = pageString;  
                    }  
          }  
}  
  
  
function findFrameContaining (master, side, text)  
{  
          var masterPage;  
          var i;  
  
          if (master.pages.length > 1)  
                    masterPage = master.pages[side];  
          else  
                    masterPage = master.pages[0];  
          for (i=0; i<masterPage.textFrames.length; i++)  
          {  
                    if (masterPage.textFrames[i].contents.indexOf(text) > -1)  
                              return masterPage.textFrames[i];  
          }  
          // Not found? Perhaps on this Master's Master?  
          if (master.appliedMaster != null)  
                    return findFrameContaining (master.appliedMaster, side, text);  
          return null;  
}  
  
  
// Needed because the very useful label lookup was  
// -- totally unnecessarily! -- removed in CS5+ ...  
function findByLabel (items, label)  
{  
          var i;  
          for (i=0; i<items.length; i++)  
                    if (items[i].label == label)  
                              return items[i];  
          return null;  
}  
  
//Метод Math.floor() возвращает наибольшее целое число, которое меньше или равно данному числу. Math.floor(7.1) выдаст 7  
function numberToText(number) {
    var ones = ["ноль", "один", "два", "три", "четыре", "пять",
        "шесть", "семь", "восемь", "девять", "десять",
        "одиннадцать", "двенадцать", "тринадцать", "четырнадцать", "пятнадцать",
        "шестнадцать", "семнадцать", "восемнадцать", "двадцать"];
    var tens = ["ноль", "десять", "двадцать", "тридцать", "сорок", "пятьдесят",
        "шесдесят", "семьдесят", "восемьдесят", "девяносто"];
        
    var hans = ["ноль", "сто", "двести", "триста", "четыреста", "пятьсот", "шестьсот", "семьсот", "восемьсот", "девятсот"];
    
    var result = '';


    if (number < 0) return "ha ha";
    if (number == 0) return ones[0];


    if (number >= 1000) {
        thousand = Math.floor(number / 1000);
        if (thousand > 1) {
            if (thousand > 4) {
                result = numberToText(thousand) + " тысяч"
                
                }
            else {
            result = numberToText(thousand) + " тысячи";
            }
        } else {
            result = "тысяча";
        }
        number = number - 1000 * thousand;
        if (number > 0) result = result + " ";
    }


    if (number >= 100) {
        hundred = Math.floor(number / 100);
        
            result = result + hans[hundred];
        
        number = number - 100 * hundred;
        if (number != 0) result = result + " ";
    }

/*
    if (number >= 60) {
        if (number >= 80) {
            twenty = number - 80;
            result = result + tens[8];

            if (twenty != 0) {
                result = result + " " + ones[twenty];
            }else{
                result = result + "s";
            }
        } else if (number >= 60) {
            twenty = number - 60;
            result = result + tens[6];

            if (twenty == 1 || twenty == 11) {
                result = result + " " + ones[twenty];
            } else if (twenty != 0 && twenty != 1 && twenty != 11) {
                result = result + " " + ones[twenty];
            }
        }

    }

*/
    if (number >= 20) {
        ten = Math.floor(number / 10);
        result = result + tens[ten];
        number = number - 10 * ten;
        if (number == 1) {
            result = result + " ";
        }
        if (number != 0 && number != 1) result = result + " ";
    }
    if (number != 0 && (number < 60 || number > 99)) result = result + ones[number];


    return result;
}